
sql2perl : psql.o psql_l.o main.o action.o
	${CC} -o $@ psql.o psql_l.o main.o action.o -lfl

psql_l.c : psql.l psql.h
	${LEX} -t psql.l > psql_l.c

psql.h psql.c : psql.y
	${YACC} -d psql.y
	mv y.tab.c psql.c
	mv y.tab.h psql.h

test:
	cd TEST ; make gen test

clean :
	-rm sql2perl *.o psql.h psql.c psql_l.c *% core
	-cd TEST ; make clean
