%{
#include <stdio.h>

static int	allproj;	/* projeter toutes les relations */

int		numquery;		/* numero de query */

#define STRSIZE	1024
char		strclos[STRSIZE];
char		strproj[STRSIZE];
char		strtemp[STRSIZE];

%}


/* ------------------ Starting Rule --------------------------------- */
%start program
/* ------------------------------------------------------------------ */

%union {
	char*	str;
	int	integer;
}

/* ------------------------------------------------------------------ */

%token  		SELECT FROM WHERE AND
%token  		EQ NEQ
%token  <str> 	  	IDENT_PT
%token  <str> 	  	IDENT
%token  <str> 	  	STRING
%token  <integer> 	INTEGER


/* ------------------------------------------------------------------ */

%left   AND 

%%
/* --------------------- Regles de production ---------------------- */

program	:
{
	numquery=1;
	printf("#!/usr/bin/perl\n");
	printf("# Beginning of program\n");
}
program2
{
	printf("\n# End of program");
}
;

program2
: query
| program2 query
;

query
:
{
	printf("\n# Beginning of query %d\n",numquery);
	allproj = 0;
	strtemp[0] = 0;
	strclos[0] = 0;
	strproj[0] = 0;

}
select_statem from_statem where_statem ';'
{
	printf("%s",strproj );
	printf("%s",strclos );
	printf("\n# End of query %d\n\n",numquery++);

}
;

/* ------------------------------------------------------------------ */
select_statem
: SELECT '*' 
{
	allproj = 1;
}
|
SELECT list_select
;


list_select
:
{
	action01();
}
list_select2
{
	action02();
}
;

list_select2
: attproj
| list_select2 
{
	action03();
}
',' attproj
;

attproj
: IDENT_PT '.' INTEGER
{
		action04($1,$3);
}
;

/* ------------------------------------------------------------------ */
from_statem
:
{
	if(allproj==1) /* projeter toutes les relations */
		action05();
}
FROM	list_from
{
	if(allproj==1) /* projeter toutes les relations */
		action06();
}
;


list_from
: table
| list_from ',' table
;

table
: IDENT
{
	action07($1);
	action08($1);
	if(allproj==1) { /* projeter toutes les relations */
		action09($1);
	}
}
;

/* ------------------------------------------------------------------ */
where_statem
: 
|
WHERE list_where 
;

list_where
:
{
	action10();
}
list_where2
{
	action11();
}
;

list_where2
: cond
|
list_where2 
{
	action12();
}
AND cond
;

cond
: IDENT_PT '.' INTEGER EQ IDENT_PT '.' INTEGER
{
	action13($1, $3, "eq", $5, $7 );
}
| IDENT_PT '.' INTEGER EQ STRING
{
	action14($1, $3, "eq", $5 );
}
| IDENT_PT '.' INTEGER NEQ IDENT_PT '.' INTEGER
{
	action13($1, $3, "ne", $5, $7 );
}
| IDENT_PT '.' INTEGER NEQ STRING
{
	action14($1, $3, "ne", $5 );
}
;

%%
